<?php
class DB
{
	var $sql;
	var $fetch;
	var $param = array();
	
	public function __construct($sql, $fetch, $param = array())
	{
		$this->sql = $sql;
		$this->fetch = $fetch;
		$this->param = $param;
		require($_SERVER["DOCUMENT_ROOT"] . "/configs/config.inc.php");
		require($_SERVER["DOCUMENT_ROOT"] . "/configs/IN_HL_config.php");
		$this->dbhost = & $ll_dbhost;
		$this->dbuser = & $ll_dbuser;
		$this->dbpw = & $ll_dbpw;
		$this->dbname = & $ll_dbname;
		if (!defined("IN_HL"))
		{
			exit;
		}
	}
	
	public function query()
	{
		$mysqli = new mysqli($this->dbhost, $this->dbuser, $this->dbpw, $this->dbname);
		if ($mysqli->connect_errno)
		{
			echo "无法连接数据库";
			return false;
		}
		$mysqli->query('SET NAMES UTF8');
		$mysqli->begin_transaction(MYSQLI_TRANS_START_READ_ONLY);
		$stmt = $mysqli->stmt_init();
		$stmt->prepare($this->sql);
		if (count($this->param) > 0)
		{
			$type = "";
			for ($i = 0; $i < count($this->param); $i++)
			{
				if (is_double($this->param[$i]))
				{
					$type .= "d";
				}
				else if (is_int($this->param[$i]))
				{
					$type .= "i";
				}
				else if (is_string($this->param[$i]))
				{
					$type .= "s";
				}
				else
				{
					$type .= "b";
				}
			}
			$refarg = array($type);
			for ($i = 0; $i < count($this->param); $i++)
			{
				$refarg[] = & $this->param[$i];
			}
			call_user_func_array(array($stmt, "bind_param"), $refarg);
		}
		if (!$stmt->execute())
		{
			echo "读取数据库时发生错误：" . $stmt->error;
			$mysqli->rollback();			
			return false;
		}
		$mysqli->commit();
		if (strtolower(substr($this->sql, 0, 6)) == "select")
		{
			$this->res = $stmt->get_result();
			$stmt->free_result();
			return $this->getres();
		}
		else
		{
			$stmt->free_result();
			return true;
		}
	}
	
	public function getres()
	{
		switch(strtolower($this->fetch))
		{
			case "all":
				$row = $this->res->fetch_all();
				break;
			case "array":
				$row = $this->res->fetch_array();
				break;
			case "assoc":
				$row = $this->res->fetch_assoc();
				break;
			case "field":
				$row = $this->res->fetch_field();
				break;
			case "row":
				$row = $this->res->fetch_row();
				break;
			default:
				echo "Please select a row return mode.";
				exit;
		}
		return $row;
	}
	
	public function numrow()
	{
		if (isset($this->res))
		{
			return $this->res->num_rows;
		}
		else
		{
			return false;
		}
	}
}
?>
