<?php
class pdoDB
{
	var $sql;
	var $param = array();
	var $fetch;
	
	public function __construct($sql, $fetch, $param)
	{
		$this->sql = $sql;
		$this->fetch = $fetch;
		$this->param = $param;
		require($_SERVER["DOCUMENT_ROOT"] . "/configs/config.inc.php");
		require($_SERVER["DOCUMENT_ROOT"] . "/configs/IN_HL_config.php");
		$this->dbhost = & $ll_dbhost;
		$this->dbuser = & $ll_dbuser;
		$this->dbpw = & $ll_dbpw;
		$this->dbname = & $ll_dbname;
		if (!defined("IN_HL"))
		{
			exit;
		}
	}
	
	public function query()
	{
		try
		{
			$pdo = new PDO(DBTYPE . ":host=$this->dbhost;dbname=$this->dbname", $this->dbuser, $this->dbpw);
			$pdo->query('SET NAMES UTF8');
			$pdo->beginTransaction();
			$stmt = $pdo->prepare($this->sql);
			if (count($param) > 0)
			{
				for ($i = 0; $i < count($this->param); $i++)
				{
					$stmt->bindParam($i + 1, $this->param[$i]);
				}
			}
			if (!$stmt->execute())
			{
				echo "读取数据库时发生错误：" . $stmt->error();
				$pdo->rollback();
				return false;
			}
			$pdo->commit();
			if (strtolower(substr($this->sql, 0, 6)) == "select")
			{
				$this->res = $stmt->get_result();
				$stmt->free_result();
				return $this->getres();
			}
			else
			{
				$stmt->free_result();
				return true;
			}
		}
		catch (PDOException $e)
		{
			echo "无法连接数据库";
			$pdo->rollback();
			return false;
		}
	}
	
	public function getres()
	{
		switch(strtolower($this->fetch))
		{
			case "all":
				$row = $this->res->fetchAll(PDO::FETCH_ASSOC);
				break;
			case "array":
				$row = $this->res->fetch(PDO::FETCH_BOTH);
					break;
			case "assoc":
			case "field":
				$row = $this->res->fetch(PDO::FETCH_ASSOC);
				break;
			case "row":
				$row = $this->res->fetch(PDO::FETCH_NUM);
				break;
			default:
				echo "Please select a row return mode.";
				exit;
		}
		return $row;
	}
	
	public function numrow()
	{
		if (isset($this->res))
		{
			return $this->res->num_rows;
		}
		else
		{
			return false;
		}
	}
}
?>
